#include <shogun/base/init.h>
#include <shogun/base/some.h>
#include <shogun/lib/WrappedObjectArray.h>
#include <shogun/io/SerializableAsciiFile.h>

using namespace shogun;

int main(int, char*[])
{
init_shogun_with_defaults();

auto true_literal = true;
auto false_literal = false;

auto str_literal = "This is a string literal.";
auto char_literal = 'w';

auto int_literal = 3;

// float is 32 bit and value has 'f' at the end.
auto float32_literal = 3.0f;

// real is 64 bit.
auto float64_literal = 3.0;

// Serialize output for integration testing (automatically generated)
auto __sg_storage = some<CWrappedObjectArray>();
auto __sg_storage_file = some<CSerializableAsciiFile>("literals.dat", 'w');
__sg_storage->append_wrapped_int(int_literal, "int_literal");
__sg_storage->append_wrapped_float(float32_literal, "float32_literal");
__sg_storage->append_wrapped_real(float64_literal, "float64_literal");
__sg_storage->save_serializable(__sg_storage_file);

exit_shogun();
return 0;
}
