#include <shogun/base/init.h>
#include <shogun/base/some.h>
#include <shogun/lib/SGMatrix.h>
#include <shogun/lib/WrappedObjectArray.h>
#include <shogun/io/SerializableAsciiFile.h>

using namespace shogun;

int main(int, char*[])
{
init_shogun_with_defaults();

auto bool_matrix = SGMatrix<bool>(2, 3);
bool_matrix(0, 0) = false;
bool_matrix(1, 0) = true;
bool_matrix(0, 1) = false;
bool_matrix(1, 1) = true;
bool_matrix(0, 2) = false;
bool_matrix(1, 2) = true;
auto bool_element = bool_matrix(1, 0);
bool_matrix(0, 0) = bool_element;

auto byte_matrix = SGMatrix<uint8_t>(2, 3);
byte_matrix(0, 0) = 0;
byte_matrix(1, 0) = 1;
byte_matrix(0, 1) = 0;
byte_matrix(1, 1) = 1;
byte_matrix(0, 2) = 0;
byte_matrix(1, 2) = 1;
byte_matrix(0, 0) = byte_matrix(1, 0);

auto word_matrix = SGMatrix<uint16_t>(2, 3);
word_matrix(0, 0) = 0;
word_matrix(1, 0) = 1;
word_matrix(0, 1) = 0;
word_matrix(1, 1) = 1;
word_matrix(0, 2) = 0;
word_matrix(1, 2) = 1;
word_matrix(0, 0) = word_matrix(1, 0);

auto int_matrix = SGMatrix<int32_t>(2, 3);
int_matrix(0, 0) = 0;
int_matrix(1, 0) = 1;
int_matrix(0, 1) = 0;
int_matrix(1, 1) = 1;
int_matrix(0, 2) = 0;
int_matrix(1, 2) = 1;
int_matrix(0, 0) = int_matrix(1, 0);

auto long_int_matrix = SGMatrix<int64_t>(2, 3);
long_int_matrix(0, 0) = 0;
long_int_matrix(1, 0) = 1;
long_int_matrix(0, 1) = 0;
long_int_matrix(1, 1) = 1;
long_int_matrix(0, 2) = 0;
long_int_matrix(1, 2) = 1;
long_int_matrix(0, 0) = long_int_matrix(1, 0);

auto short_real_matrix = SGMatrix<float32_t>(2, 3);
short_real_matrix(0, 0) = 0.0f;
short_real_matrix(1, 0) = 1.0f;
short_real_matrix(0, 1) = 0.0f;
short_real_matrix(1, 1) = 1.0f;
short_real_matrix(0, 2) = 0.0f;
short_real_matrix(1, 2) = 1.0f;
short_real_matrix(0, 0) = short_real_matrix(1, 0);

auto real_matrix = SGMatrix<float64_t>(2, 3);
real_matrix(0, 0) = 0.1;
real_matrix(1, 0) = 0.1;
real_matrix(0, 1) = 0.1;
real_matrix(1, 1) = 0.1;
real_matrix(0, 2) = 0.1;
real_matrix(1, 2) = 0.1;
real_matrix(0, 0) = real_matrix(1, 0);

//LongRealMatrix long_real_matrix(2,3)
//long_real_matrix[0,0]=0.1
//long_real_matrix[1,0]=0.1
//long_real_matrix[0,1]=0.1
//long_real_matrix[1,1]=0.1
//long_real_matrix[0,2]=0.1
//long_real_matrix[1,2]=0.1
//long_real_matrix[0,0]=long_real_matrix[1,0]

// Serialize output for integration testing (automatically generated)
auto __sg_storage = some<CWrappedObjectArray>();
auto __sg_storage_file = some<CSerializableAsciiFile>("matrix_types.dat", 'w');
__sg_storage->append_wrapped_real_matrix(real_matrix, "real_matrix");
__sg_storage->save_serializable(__sg_storage_file);

exit_shogun();
return 0;
}
