#include <shogun/base/init.h>
#include <shogun/base/some.h>
#include <shogun/io/SerializableAsciiFile.h>
#include <shogun/lib/SGVector.h>
#include <shogun/lib/WrappedObjectArray.h>

using namespace shogun;

int main(int, char*[])
{
init_shogun_with_defaults();

auto bool_vector = SGVector<bool>(2);
bool_vector[0] = false;
bool_vector[1] = true;
auto bool_element = bool_vector[1];
bool_vector[0] = bool_element;

auto byte_vector = SGVector<uint8_t>(2);
byte_vector[0] = 0;
byte_vector[1] = 1;
byte_vector[0] = byte_vector[1];

auto word_vector = SGVector<uint16_t>(2);
word_vector[0] = 0;
word_vector[1] = 1;
word_vector[0] = word_vector[1];

auto int_vector = SGVector<int32_t>(2);
int_vector[0] = 0;
int_vector[1] = 1;
int_vector[0] = int_vector[1];

auto long_int_vector = SGVector<int64_t>(2);
long_int_vector[0] = 0;
long_int_vector[1] = 1;
long_int_vector[0] = long_int_vector[1];

auto short_real_vector = SGVector<float32_t>(2);
short_real_vector[0] = 0.0f;
short_real_vector[1] = 1.0f;
short_real_vector[0] = short_real_vector[1];

auto real_vector = SGVector<float64_t>(2);
real_vector[0] = 0.1;
real_vector[1] = 0.1;
real_vector[0] = real_vector[1];

//LongRealVector long_real_vector(2)
//long_real_vector[0]=0.1
//long_real_vector[1]=0.1
//lont_real_vector[0]=long_real_vector[1]

// Serialize output for integration testing (automatically generated)
auto __sg_storage = some<CWrappedObjectArray>();
auto __sg_storage_file = some<CSerializableAsciiFile>("vector_types.dat", 'w');
__sg_storage->append_wrapped_real_vector(real_vector, "real_vector");
__sg_storage->save_serializable(__sg_storage_file);

exit_shogun();
return 0;
}
